program Graph_32a;
{
      
}
{$APPTYPE CONSOLE}

uses
  SysUtils,
  DateUtils,
  Assembly in '..\Common\Assembly.pas',
  Graph in '..\Common\Graph.pas',
  GrChars in '..\Common\GrChars.pas',
  Items in '..\Common\Items.pas',
  Root in '..\Common\Root.pas',
  SetList in '..\Common\SetList.pas',
  SetUtils in '..\Common\SetUtils.pas';

var Gr : TGraph;
    Res: TBuffer;
    Res2: TSet;
    Cost: integer;

    Na, Nb, Nc : TNode;

    Start : TDateTime;

    N1, N2, Nodes, Cost1, Cost2, Time : integer;

//    

function HamToStr(aBuf: TBuffer): string;
var N: TNode;
    i: integer;
begin
  Result:='';
  for i:= 1 to aBuf.GetCount do begin
    N:= aBuf.Get as TNode;
    aBuf.Put(N);
    Result:= Result+ N.GetName;
    if i<aBuf.GetCount then Result:=Result +'-';
  end;
end;

{$define _HUGE }

begin
  try
  repeat
     Write(#10#10'Nodes= '); Readln(Nodes);
     if Nodes < 4 then Break;

    //Gr:= TGraphChars.Load('Test_1.txt');
    //Gr:= TGraphChars.Load('Full_15_1.txt');
    //Gr:= TGraphChars.Load('Full_7.txt');
    //Gr:= TGraphChars.Load('TestHam_6.txt');
    //  
    //Gr:= TGraphChars.GenRandom(false, 10, 10, 99, 60);
    {
           
       1  99 ( )
    }
{$ifdef _HUGE }
    Gr:= THugeGraph.GenFull(not false, 0, 99, Nodes);
    if Nodes < 16 then Gr.Expo;
    {           }
    Na:= Gr.NodeFirst;
    Nb:= Gr.NodeNext;
    Nc:= nil;
{$else}
    Gr:= TGraphChars.GenFull(false, 0, 99, Nodes);
    if Nodes < 16 then Gr.Expo;
    {
            (A)   (B).
            C
    }
    Na:= (Gr as TGraphChars).GetNode('B');
    Nb:= (Gr as TGraphChars).GetNode('C');
    //Nc:= (Gr as TGraphChars).GetNode('D');
    Nc:= nil;
{$endif}


    Writeln('========== Ham Path ==========='#10);
    Start:= Now;
    Res:= Gr.GenHamPath(Na, Nb, Cost1);
    //Res:= Gr.GenHamPathStrip(Na, Nb, Nc, Cost1);
    Time:= MilliSecondsBetween(Start, Now);
    Writeln(HamToStr(Res));
    Writeln('Cost Ham  = ', Cost1:4, Time:7, #10);
    Res.Free;


    Writeln('========== Ham Path Dir ==========='#10);
    Start:= Now;
    Res:= Gr.GenHamPathDir(Na, Nb, Cost1);
    Time:= MilliSecondsBetween(Start, Now);
    Writeln(HamToStr(Res));
    Writeln('Cost Dir  = ', Cost1:4, Time:7, #10);
    Res.Free;

(*
     Start:= Now;
     Res:= Gr.GenHamPathStrip(Na, Nb, nil, Cost);
     Time:= MilliSecondsBetween(Start, Now);
     Writeln(HamToStr(Res));
     Writeln('Strip NIL = ', Cost:4, Time:7:0, #10);
  N1:= Cost;
     Res.Free;
     Writeln('------------------------------------');

     Start:= Now;
     Res:= Gr.GenHamPathStrip(Na, Nb, Nc, Cost);
     Time:= MilliSecondsBetween(Start, Now);
     Writeln(HamToStr(Res));
     Writeln('Strip C   = ', Cost:4, Time:7:0, #10);
     Res.Free;
***)


    if Nodes < 18 then begin
      Writeln('========== Ham Path Full ==========='#10);
      Start:= Now;
      Res:= Gr.GenHamPath_Full(Na, Nb, Cost2);
      Time:= MilliSecondsBetween(Start, Now);
      Writeln(HamToStr(Res));
      Writeln('Cost Full = ', Cost2:4, Time:7, #10);
      Res.Free;
      Writeln('Ratio= ', 100*Cost1/Cost2 : 7:1);
    end;

    Writeln(#10'========== Ham Path Greed ==========='#10);
    Res:= Gr.GenHamPath_Greed(Na, Nb, Cost, true); // 
    Writeln('Cost Greed = ', Cost);
    Res.Free;

    Res:= Gr.GenHamPath_Greed(Na, Nb, Cost, false); // 
    Writeln('Cost Randm = ', Cost);
    Res.Free;


     Writeln('========== Cover Tree ==========='#10);
     Res2:= Gr.GenCoverTree(false, Cost);
     Res2.Expo;
     Writeln('Cost Cover Tree = ', Cost);
     Res2.ClrAndDestroy;
     Res2.Free;


     Writeln('========== Ham Cycle ==========='#10);
     Start:= Now;
     Res:= Gr.GenHamilton_Full(Cost);
     Time:= MilliSecondsBetween(Start, Now);
     Res.Free;
     Writeln('Ham Cycle Full= ', Cost:4, Time:7);


     Start:= Now;
     Res:= Gr.GenHamilton(Cost);
     Time:= MilliSecondsBetween(Start, Now);
     Writeln(HamToStr(Res));
     Writeln('Ham Cycle  = ', Cost:4, Time:7);
     Res.Free;
     N2:= Cost;

     Start:= Now;
     Res:= Gr.GenHamilton_Quick(Cost);
     Time:= MilliSecondsBetween(Start, Now);
     Writeln(HamToStr(Res));
     Writeln('Ham Quick  = ', Cost:4, Time:7);
     Res.Free;
     N1:= Cost;
     Writeln('Ratio= ', 100*N1/N2 : 7:1);

    Gr.Free;
  until false;
  except
    on E:Exception do
      Writeln(E.Classname, ': ', E.Message);
  end;
end.
