program Graph_33b;
{
      
   ,    
}
{$APPTYPE CONSOLE}

uses
  SysUtils,
  DateUtils,
  Assembly in '..\Common\Assembly.pas',
  Graph in '..\Common\Graph.pas',
  GrChars in '..\Common\GrChars.pas',
  Items in '..\Common\Items.pas',
  Root in '..\Common\Root.pas',
  SetList in '..\Common\SetList.pas',
  SetUtils in '..\Common\SetUtils.pas';
{-------------------------------------------------------}

procedure Test(aRetry, aNodes: integer);
var Gr : TGraph;            //  
    Res : TBuffer;          //  -  
    Cost, CostFull: integer;          // 
    Sum2, Sum3, Sum4, Sum5: Extended; //     %
    Max2, Max3, Max4, Max5: Extended; //    
    OK2, OK3, OK4, OK5: integer;      //    

    T1, T2, T3, T4, T5 : integer; //  
    Start : TDateTime;            //   

    Cnt : integer;     //  
    Delta : integer;   //  
    pc :  extended;    //   %

   //  
  procedure Expo(const aFile: String);
  const CLine='--------------------------------------------------------------';
  var  x1, x2, x3, x4, x5 : Extended;
  begin
    if aFile <> '' then begin
      Assign(Output, aFile);
      if FileExists(aFile)  then Append(Output)   else Rewrite(Output)
    end;
    Writeln(CLine);
    Writeln('Retry=', aRetry:4,  '  Nodes=', aNodes:4);
    Writeln(CLine);
    Writeln('                 Full      Ham      Greed    Random     Quick');
    //  , %:
    x2:= Sum2/aRetry;
    x3:= Sum3/aRetry;
    x4:= Sum4/aRetry;
    x5:= Sum5/aRetry;
    Write('Ratio(%) = ', '':10, x2:10:1, x3:10:1, x4:10:1);
    if aNodes > 0 then Writeln else Writeln(x5:10:1);

    //    
    Write('MaxR (%) = ', '':10, Max2:10:1, Max3:10:1, Max4:10:1);
    if aNodes > 0 then Writeln else Writeln(Max5:10:1);
    //      
    Write('OK   (%) = ', '':10, 100*OK2/aRetry:10:1,
                100*OK3/aRetry:10:1, 100*OK4/aRetry:10:1);
    if aNodes > 0 then Writeln else Writeln(100*OK5/aRetry:10:1);
    //  , 
    x1:= T1/aRetry; x2:= T2/aRetry; x3:= T3/aRetry; x4:= T4/aRetry;
    x5:= T5/aRetry;
    Write('Time (ms)= ', x1:10:1, x2:10:1, x3:10:1, x4:10:1);
    if aNodes > 0 then Writeln else Writeln(x5:10:1);

    Writeln(CLine);
    if aFile <> '' then begin
      Close(Output);  Assign(Output, '');    Rewrite(Output);
    end;
  end;

begin  { Test }

    //     %
    Sum2:= 0; Sum3:= 0; Sum4:= 0; Sum5:=0;
    //    
    Max2:= 0; Max3:=0; Max4:=0; Max5:=0;
    //    
    OK2:=0; OK3:=0; OK4:=0; OK5:=0;
    //  
    T1:=0; T2:=0; T3:=0; T4:=0; T5:=0;

    for Cnt:= 1 to aRetry do begin

      // aNodes>0 - ,  aNodes<0 - 
      //Gr:= TGraphChars.GenFull((aNodes>0), 0, 99, Abs(aNodes));
      Gr:= THugeGraph.GenFull((aNodes>0), 0, 99, Abs(aNodes));

      if Abs(aNodes) > 15 then CostFull:=-1
      else begin
        {-------- Full -------}
        Start:= Now;
        Res:= Gr.GenHamilton_Full(CostFull);
        Inc(T1, MilliSecondsBetween(Start, Now));
        Res.Free;
      end;

      {-------- Main -------}
      Start:= Now;
      Res:= Gr.GenHamilton(Cost);
      Inc(T2, MilliSecondsBetween(Start, Now));
      Res.Free;
      if CostFull < 0 then CostFull:= Cost;
      Delta:= Cost - CostFull;
      if Delta=0 then Write('.') else Write('*');
      if Delta = 0 then Inc(OK2);
      pc:= 100 * Cost/CostFull;
      Sum2:= Sum2 + pc;
      if Max2 < pc then Max2:= pc;

      {-------- Greed -------}
      Start:= Now;
      Res:= Gr.GenHamilton_Greed(Cost, true);
      Inc(T3, MilliSecondsBetween(Start, Now));
      Res.Free;
      Delta:= Cost - CostFull;
      if Delta = 0 then Inc(OK3);
      pc:= 100 * Cost/CostFull;
      Sum3:= Sum3 + pc;
      if Max3 < pc then Max3:= pc;

      {-------- Random -------}
      Start:= Now;
      Res:= Gr.GenHamilton_Greed(Cost, false);
      Inc(T4, MilliSecondsBetween(Start, Now));
      Res.Free;
      Delta:= Cost - CostFull;
      if Delta = 0 then Inc(OK4);
      pc:= 100 * Cost/CostFull;
      Sum4:= Sum4 + pc;
      if Max4 < pc then Max4:= pc;

      {-------- Quick -------}
      Start:= Now;
      Res:= Gr.GenHamilton_Quick(Cost);
      Inc(T5, MilliSecondsBetween(Start, Now));
      Res.Free;
      Delta:= Cost - CostFull;
      if Delta = 0 then Inc(OK5);
      pc:= 100 * Cost/CostFull;
      Sum5:= Sum5 + pc;
      if Max5 < pc then Max5:= pc;

      Gr.Free;
    end; // for
    Writeln(#7);
    //  
    Expo('');
//    Expo('Out_19b_2015-08-02.txt');
end;

{-------------------------------------------------------}

var Nodes: integer;
    Retry : integer;

begin
  try
    Write('Retry= '); Readln(Retry);
    if Retry <= 0 then Exit;

    repeat
      Write('Nodes= '); Readln(Nodes);
      if Abs(Nodes) < 4 then Break;
      Test(Retry, Nodes);
    until false;

  except
    on E:Exception do
      Writeln(E.Classname, ': ', E.Message);
  end;
end.
